varying vec3 v_normal;

// 新的点光的世界坐标
uniform vec3 u_PointLightWorldPosition;

varying vec3 v_vertexToPointLightDirection;

// pool start

attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord;

varying vec3 v_reflect;
varying vec2 v_textureCoordOut;
varying vec3 v_eyeVertex;

uniform vec3 u_eyePosition;
uniform mat4 u_modelMat;
uniform mat4 u_normalMat;
uniform mat4 u_viewMat;
uniform mat4 u_projMat;

void main(void)
{
    // 像素世界坐标
    vec4 mvPosition = CC_MVMatrix * a_position;
    
    // 像素指向点光源向量
    v_vertexToPointLightDirection = u_PointLightWorldPosition - mvPosition.xyz;

    // 法向量
    v_normal = CC_NormalMatrix * a_normal;

    // gl_Position
    gl_Position = u_projMat * u_viewMat * u_modelMat * a_position;

    // 环境盒子的反射向量
    vec4 positionWorldViewSpace = u_modelMat * a_position;
    v_eyeVertex = normalize(u_eyePosition - positionWorldViewSpace.xyz);
    v_reflect = normalize(reflect(-v_eyeVertex, v_normal));

    // 纹理uv
    v_textureCoordOut = a_texCoord;
    v_textureCoordOut.y = 1.0 - v_textureCoordOut.y;
}
